clear all 
close all 
clc 

%========================================================================
% Simulating Random Sampling 
%========================================================================
path(path,'C:\Users\NJN\Dropbox\IEEE_BIG_DATA_PROJECT\MatlabAnalysis\SerialWork\Data')
tic 

            
            %---------- Initialize and Generate Random Image (Not from Source Images)
            S=99 ;  % Number of Sources
            C=36;   % Number of Characters 
            NumExp=10; % Number of Experiments to Run 
            MaxImag=999; % Max Number of Sources Available in the Data Base 
            RC = randi([1,C],[1 NumExp]); % Vector of Characters 
            RS = randi([S+1,MaxImag],[1 NumExp]);  % Vector of Soruces 
            
 for NJN=1:NumExp  % Indexer for Random Images 
                   
            % ---------------------- Picking Random Image ---------------------------------- 
                        if RC(NJN)<10
                                if RS(NJN)<100
                                   BScript=['img00' num2str(RC(NJN)) '-000' num2str(RS(NJN)) '.png'];
                                elseif RS(NJN)>99
                                   BScript=['img00' num2str(RC(NJN)) '-00' num2str(RS(NJN)) '.png'];
                                end
                        elseif RC(NJN)>9 % For the additional 10th image
                            if RS(NJN)<100
                               BScript=['img0' num2str(RC(NJN)) '-000' num2str(RS(NJN)) '.png'];
                            elseif RS(NJN)>99
                               BScript=['img0' num2str(RC(NJN)) '-00' num2str(RS(NJN)) '.png'];
                            end 
                        end 
            %-------------------------Getter and Setter (Global Variable)----------------------------------       
                 SimImage=(imread(BScript));  % (1st number of the font class / second number is the character)
                 save('ImageHolder','SimImage');
%========================================================================
% MapReduce Process 
%========================================================================

ds = datastore('C:\Users\NJN\Dropbox\IEEE_BIG_DATA_PROJECT\MatlabAnalysis\MapReduceWork\SourcesDataCSVFiles/*.csv');

     %-----Systems Processing Specs: 
            % Option #1 
                %mapreducer(0)
            % Option #2 
                 %parpool('local',4)  
                 p=gcp;
                 mapreducer(p);
     %------------------------------
FusionDS_Eval = mapreduce(ds, @CorrDSMapper, @DSFusionReducer);

results = readall(FusionDS_Eval);
MASSES(:,NJN)=(results.Value{:,1})
 end 
 
[V,I]=max(MASSES(1:36,:));
figure; 
plot(V,MASSES(37,:),'r*')
hold on ;
Loc=(I==RC);
plot(V(Loc),MASSES(37,Loc),'b*','linewidth',1.23)
xlabel('Mass')
ylabel('Uncertainty')

 
 
toc 