#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "lodepng.h"

void shuffle(int *array, size_t n)
{
    if (n > 1) 
    {
        size_t i;
        for (i = 0; i < n - 1; i++) 
        {
          size_t j = i + rand() / (RAND_MAX / (n - i) + 1);
          int t = array[j];
          array[j] = array[i];
          array[i] = t;
        }
    }
}

int main (int argc, char ** argv) {
    // forward declarations
    char filename[256], outfilename[256];
    int maxchars = 36;
    int maxsource = 999;
    int numexp = 250;
    int charnum=1, sourcenum=1; 

    int i, j;

    unsigned int error, width, height;
    unsigned char * image;

    int randoms[maxsource];
    
    FILE *fp;

    // end forward declarations

    // seed rng
    srand((unsigned int)time(NULL));
    
    // make vector of ints from 1-999
    for (i=1; i<=maxsource; i++) {
        randoms[i-1]=i;
    }


    shuffle(randoms, maxsource);
    /* randoms is now a random list of non repeated integers from 1-999 inclusive*/
    /* we can take the first 250 entries (or any number) for ground truth */
        

    


    for (i=charnum; i<=maxchars; i++) {
        for (j=sourcenum; j<=maxsource; j++) {
            memset(filename, 0x00, sizeof(char)*256);
            memset(outfilename, 0x00, sizeof(char)*256);


            sprintf(filename, "/home/kleach/nickdata/FontData/img%03d-%05d.png", i, j);
            sprintf(outfilename, "/home/kleach/nickdata/MapReduceWork/redux/font-dump/i%d-%d.dat", i, j);
    
            error = lodepng_decode_file(&image, &width, &height, 
                                        filename, LCT_GREY, (unsigned int) 8);

            if (error) printf("error %u: %s\n", error, lodepng_error_text(error));
            fp = fopen(outfilename, "wb");

            fwrite(image, sizeof(unsigned char), sizeof(unsigned char)*width*height, fp); 
            fclose(fp);
            
            free(image);
        }
    }







    return 0;
}
