#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

#define DIM 128

// global decs...


unsigned char *** images;



/* produces a cross correlation value a la Matlab
 *  INPUT 2 arrays of ints, assumed to be of size DIMxDIM
 *  OUTPUT cross correlation value
 */

/*   sum_m (sum_n (  ( A[m][n] - avg_a ) * ( B[m][n] - avg_b ) ) )   
 *             /   
 *   Sqrt( (sum_m(sum_n( (A[m][n]-avg_a)^2 ))) * (sum_m(sum_n( (B[m][n]-avg_b)^2 ))))
 *
 */

double corr2 (unsigned char *a, unsigned char *b) {
    double avg_a=0.0f, avg_b=0.0f;
    int i=0, j=0;
    
    double numerator_sum=0.0f;
    double denom_sum1=0.0f, denom_sum2=0.0f;

    double sum_a=0.0f;
    double sum_b=0.0f;

    double ret;
    for (i=0; i<DIM; i++) {
        for (j=0; j<DIM; j++) {
            sum_a += a[i*DIM+j];
            sum_b += b[i*DIM+j];
        }
    }

    avg_a = sum_a / (double)(DIM*DIM);
    avg_b = sum_b / (double)(DIM*DIM);

    for (i=0; i<DIM; i++) {
        for (j=0; j<DIM; j++) {
            numerator_sum += (a[i*DIM+j] - avg_a) * (b[i*DIM+j] - avg_b);
            denom_sum1 += (a[i*DIM+j]-avg_a) * (a[i*DIM+j]-avg_a);
            denom_sum2 += (b[i*DIM+j]-avg_b) * (b[i*DIM+j]-avg_b);
        }
    }

    ret = numerator_sum / (sqrt(denom_sum1 * denom_sum2));
    return ret;
}

/* produces correlation vector... V(i) in Matlab
 *  INPUT vector of doubles (assumed malloc'd already)
 *        length (probably 36?)
 */
void corrvector(double * vector, int length) {
    
}



/* randomly shuffles an array of ints 
 * INPUT array of integers, length of array
 * OUTPUT mutates same array, elements in random order
 */
void shuffle(int *array, size_t n)
{
    if (n > 1) 
    {
        size_t i;
        for (i = 0; i < n - 1; i++) 
        {
          size_t j = i + rand() / (RAND_MAX / (n - i) + 1);
          int t = array[j];
          array[j] = array[i];
          array[i] = t;
        }
    }
}

/* helper function to initialize array */
shufflerandoms(int * randoms, int maxsource) {
    int i;
    for (i=1; i<=maxsource; i++) {
        randoms[i-1]=i;
    }
    shuffle(randoms, maxsource);
}

int main (int argc, char ** argv) {
    // forward declarations
    char f1[256], f2[256];
    int maxchars = 36;
    int maxsource = 999;
    int numexp = 250;
    int charnum=1, sourcenum=1; 

    int i, j;

    images = (unsigned char ***) malloc(sizeof(unsigned char **)*maxsource);
    for (i=0; i<maxsource; i++) {
        images[i] = (unsigned char**) malloc(sizeof(unsigned char*)*maxchars);
        for (j=0; j<maxchars; j++) {
            images[i][j] = (unsigned char*)malloc(sizeof(unsigned char)*DIM*DIM);
        }
    }

    int randoms[maxsource];
    
    FILE *fp1, *fp2;


    srand((unsigned int)time(NULL));
    shufflerandoms(randoms, maxsource);

    sprintf(f2, "/home/kleach/nickdata/MapReduceWork/redux/font-dump/i%d-%d.dat", 1, 2);

    for (i=0; i<maxsource; i++) {
        for (j=0; j<maxchars; j++) {
            sprintf(f1, "/home/kleach/nickdata/MapReduceWork/redux/font-dump/i%d-%d.dat", j+1, i+1);
            fp1 = fopen(f1, "rb");
            if (!fp1) {
                perror("error");
                printf("%s\n", f1);
                continue;
            }
            fread(images[i][j], sizeof(unsigned char), DIM*DIM, fp1);
            fclose(fp1);
        }
    }






//    double res = corr2(images[0][0], images[0][0]);
//    printf("%f\n", res);

    return 0;

}
