<?php

$file = './output-list-0.txt';
if (isset($argv[1])) {
    $file = file('./output-list-'.$argv[1].'.txt');
} 

function average ($array) {
    $sum = 0;
    foreach ($array as $d) {
        $sum += $d;
    }
    return $sum/count($array);
}

if (!function_exists('stats_standard_deviation')) {
    /**
     * This user-land implementation follows the implementation quite strictly;
     * it does not attempt to improve the code or algorithm in any way. It will
     * raise a warning if you have fewer than 2 values in your array, just like
     * the extension does (although as an E_USER_WARNING, not E_WARNING).
     *
     * @param array $a
     * @param bool $sample [optional] Defaults to false
     * @return float|bool The standard deviation or false on error.
     */
    function stats_standard_deviation(array $a, $sample = false) {
        $n = count($a);
        if ($n === 0) {
            trigger_error("The array has zero elements", E_USER_WARNING);
            return false;
        }
        if ($sample && $n === 1) {
            trigger_error("The array has only 1 element", E_USER_WARNING);
            return false;
        }
        $mean = array_sum($a) / $n;
        $carry = 0.0;
        foreach ($a as $val) {
            $d = ((double) $val) - $mean;
            $carry += $d * $d;
        };
        if ($sample) {
           --$n;
        }
        return sqrt($carry / $n);
    }
}

/*
$true_uncertainties = array();
$false_uncertainties = array();
$uncertainties = array();

$truemasses = array();
$falsemasses= array();
$masses = array();

$times = array();
*/

$output = '';

foreach ($file as $myfile) {
    $myfile = trim($myfile);

    $results = file($myfile);


    $trueuncs  = array();
    $falseuncs = array();
    $uncs      = array();
    
    $truemass  = array();
    $falsemass = array();
    $mass      = array();

    $time = array();

    $numsources=0;        
    
    $score = 0 ;
    $bad = 0;
    foreach ($results as $result) {
        $result = trim($result);

        list($ref, $get, $unc, $mas, $noi, $nsc, $src, $tim) = explode(',', $result); 
        
        $numsources = $nsc;

        if ($ref==$get) {
            $truemass[] = $mas;
            $trueuncs[] = $unc;
            $score++;
        } else {
            $falsemass[] = $mas;
            $falseuncs[] = $unc;
            if ($unc < .125) {
                $bad++;
            }
        }

       

        $mass[] = $mas;
        $uncs[] = $unc;

        $time[] = $tim;
    }

    $avgtime = average($time);
    $stdev = stats_standard_deviation($time);

    $avgtmass = average($truemass);
    $stdtmass = stats_standard_deviation($truemass);

    $avgfmass = average($falsemass);
    $stdfmass = stats_standard_deviation($falsemass);

    $avgmass = average($mass);
    $stdmass = stats_standard_deviation($mass);

    $avgtunc = average($trueuncs);
    $stdtunc = stats_standard_deviation($trueuncs);

    $avgfunc = average($falseuncs);
    $stdfunc = stats_standard_deviation($falseuncs);

    $avgunc = average($uncs);
    $stdunc = stats_standard_deviation($uncs);




    $output .= $numsources . ','
        . $score .','
        .$bad.','
            . $avgtime . ','
            . $stdev . ','
            . $avgtmass . ','
            . $stdtmass . ','
            . $avgfmass . ','
            . $stdfmass . ','
            . $avgmass .','
            . $stdmass . ','
            . $avgtunc . ','
            . $stdtunc . ','
            . $avgfunc . ','
            . $stdfunc . ','
            . $avgunc . ','
            . $stdunc . "\n";
   
}

print $output;

?>
